/*
 * amg8833.c
 *
 *  Created on: 25.01.2018
 *      Author: Rafa
 */

#include "stm32f0xx_hal.h"
#include "i2c.h"
#include "amg8833.h"

#define TIMEOUT 			100

static inline uint8_t _i2c_get8(int8_t address)
{
	uint8_t tmp;

	HAL_I2C_Mem_Read(&hi2c1, AMG8833_ADDRESS, address, 1, &tmp, 1, TIMEOUT);
	return tmp;
}

static inline uint16_t _i2c_get16(int8_t address)
{

	return (_i2c_get8(address+1) << 8) +  _i2c_get8(address);
}

void amg8833_10fps(void)
{

	int8_t pData = AMG8833_FPS_10;
	HAL_I2C_Mem_Write(&hi2c1, AMG8833_ADDRESS, AMG8833_FPS, 1, &pData, 1, TIMEOUT);
}

uint16_t amg8833_temperature(void)
{

	return _i2c_get16(AMG8833_THERMISTOR_L);
}

void amg8833_get_frame(uint16_t* frame)
{
	uint8_t i;

	for(i = 0; i < AMG8833_PIXELS; i++)
		frame[i] = _i2c_get16(AMG8833_PIXEL0_L+2*i);
}

void amg8833_print(uint16_t* frame)
{
	uint8_t i,j;

	printf("[\r\n");
	for (i=0; i<AMG8833_COL; i++) {
		for (j=0; j<AMG8833_ROW; j++)
			printf("%d\t", frame[i*AMG8833_ROW+j]);
		printf("\r\n");
		HAL_Delay(1);
	}
}


